// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: Vega support
// Please include the following in your index.html file
//
//      <script src="https://cdn.jsdelivr.net/npm/vega@5/build/vega.min.js"></script>
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("codemirror"), require("../addon/fold-code"), require("../addon/fold"), require("yamljs")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","codemirror","../addon/fold-code","../addon/fold","yamljs"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldCodeWithVega = this.HyperMD.FoldCodeWithVega || {}), CodeMirror, HyperMD.FoldCode, HyperMD.Fold, YAML);
})(function (require, exports, CodeMirror, fold_code_1, fold_1, YAML) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    CodeMirror = __importStar(CodeMirror);
    YAML = __importStar(YAML);
    exports.VegaRenderer = function (code, info) {
        var id = "_vega_id_" + Math.round(1e9 * Math.random()).toString(36);
        var el = document.createElement("div");
        el.id = id;
        var asyncRenderer = null;
        try {
            var spec_1 = {};
            if (code.trim()[0] !== "{") {
                spec_1 = YAML.parse(code);
            }
            else {
                spec_1 = JSON.parse(code);
            }
            asyncRenderer = function () {
                var view = new vega.View(vega.parse(spec_1), {
                    renderer: "canvas",
                    container: "#" + id
                });
                view.runAsync().then(function () {
                    if (info.changed) {
                        info.changed();
                    }
                });
            };
        }
        catch (error) {
            el.innerText = error.toString();
        }
        return {
            element: el,
            asyncRenderer: asyncRenderer
        };
    };
    if (typeof vega !== "undefined" && vega.View) {
        CodeMirror.defineOption("vega", null, function (cm) {
            fold_code_1.getAddon(cm).clear("vega");
            fold_1.getAddon(cm).startFold();
        });
        fold_code_1.registerRenderer({
            name: "vega",
            pattern: /^vega$/i,
            renderer: exports.VegaRenderer,
            suggested: true
        });
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-vega loaded.");
        }
    }
    else {
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-vega failed to load.\nPlease include  \n\n    <script src=\"https://cdn.jsdelivr.net/npm/vega@5/build/vega.min.js\"></script>\n\nin your HTML file");
        }
    }
});
